<?php
/**
 * @brief		Invite System Application Class
 * @author		<a href='http://www.sosinvison.com.br'>Adirano Faria</a>
 * @copyright	(c) 2015 Adirano Faria
 * @package		IPS Social Suite
 * @subpackage	Invite System
 * @since		30 Aug 2015
 * @version		
 */
 
namespace IPS\invite;

/**
 * Invite System Application Class
 */
class _Application extends \IPS\Application
{
	/**
	 * [Node] Get Icon for tree
	 *
	 * @note	Return the class for the icon (e.g. 'globe')
	 * @return	string|null
	 */
	protected function get__icon()
	{
		return 'ticket';
	}

	public function installOther()
	{
		foreach( \IPS\Member\Group::groups( TRUE, FALSE ) as $group )
		{
			if( $group->g_id == \IPS\Settings::i()->admin_group )
			{
				\IPS\invite\Member\Group::setGroupData( $group->g_id, 1, 1 );
			}
			else
			{
				\IPS\invite\Member\Group::setGroupData( $group->g_id, 1, 0 );
			}
		}

		\IPS\Application::load('invite')->enabled = 1;
		\IPS\Application::load('invite')->save();
		\IPS\Task::queue( 'invite', 'membersOffset', array(), 1 );
	}

	public function getWebhooks() : array
	{
		return array_merge( array( 'is_account_registered'  => array( 'inviter' => \IPS\Member::class, 'inviteer' => \IPS\Member::class ) ), parent::getWebhooks() );
	}

	/**
	 * Init
	 *
	 * @param	void
	 */
	public function init()
	{
		static::checkGroupsCache();
	}

	public static function checkGroupsCache()
	{
		if( !isset( \IPS\Data\Store::i()->inviteGroups ) )
		{
			\IPS\invite\Member\Group::updateGroupCache();
		}
	}
}