<?php
/**
 * @brief		Admin CP Member Form
 * @author		<a href='http://www.invisionpower.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) 2001 - 2016 Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/legal/standards/
 * @package		IPS Community Suite
 * @subpackage	Invite System
 * @since		10 Apr 2016
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\invite\extensions\core\MemberForm;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Admin CP Member Form
 */
class _Invite
{
	/**
	 * Process Form
	 *
	 * @param	\IPS\Helpers\Form		$form	The form
	 * @param	\IPS\Member				$member	Existing Member
	 * @return	void
	 */
	public function process( &$form, $member )
	{		
		$user = \IPS\invite\Member::getMember( $member );

		$form->add( new \IPS\Helpers\Form\Number( 'invites_remaining', $user->invites_remaining, FALSE, array( 'min' => 0 ) ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'revoke_access', $user->revoke_access ) );
	}

	/**
	 * Save
	 *
	 * @param	array				$values	Values from form
	 * @param	\IPS\Member			$member	The member
	 * @return	void
	 */
	public function save( $values, &$member )
	{
		$user = \IPS\invite\Member::getMember( $member );
		$user->invites_remaining = $values['invites_remaining'];
		$user->revoke_access	 = $values['revoke_access'];
		$user->save();

		\IPS\Member::clearCreateMenu();

		unset( $values['invites_remaining'] );
		unset( $values['revoke_access'] );
	}
}