<?php
/**
 * @brief		Notification Options
 * @author		<a href='https://www.invisioncommunity.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) Invision Power Services, Inc.
 * @license		https://www.invisioncommunity.com/legal/standards/
 * @package		Invision Community
 * @subpackage	Invite System
 * @since		30 May 2019
 */

namespace IPS\invite\extensions\core\Notifications;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * Notification Options
 */
class _inviteSystem
{
	public static function configurationOptions( \IPS\Member $member = NULL )
	{
		return array(
			'account_converted'	=> array(
				'type'				=> 'standard',
				'notificationTypes'	=> array( 'account_converted' ),
				'title'				=> 'notifications__invite_inviteSystem',
				'showTitle'			=> FALSE,
				'description'		=> 'notifications__invite_inviteSystem_desc',
				'default'			=> array( 'inline', 'email' ),
				'disabled'			=> array()
			)
		);
	}

	public function parse_account_converted( \IPS\Notification\Inline $notification )
	{
		$item = $notification->item;
		if ( !$item )
		{
			throw new \OutOfRangeException;
		}

		return array(
			'title'		=> \IPS\Member::loggedIn()->language()->addToStack( 'notification__account_converted', FALSE, array( 'sprintf' => array( $item->name ) ) ),
			'url'		=> $item->url(),
			'author'	=> $item,
		);
	}
}