<?php
/**
 * @brief		inviteSystem
 * @author		<a href='https://www.invisioncommunity.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) Invision Power Services, Inc.
 * @license		https://www.invisioncommunity.com/legal/standards/
 * @package		Invision Community
 * @subpackage	Invite System
 * @since		31 May 2019
 */

namespace IPS\invite\extensions\nexus\Item;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * inviteSystem
 */
class _inviteSystem extends \IPS\nexus\Invoice\Item\Charge // or \IPS\nexus\Invoice\Item\Purchase
{
	/**
	 * @brief	Application
	 */
	public static $application = 'invite';

	/**
	 * @brief	Application
	 */
	public static $type = 'Tickets';

	/**
	 * @brief	Icon
	 */
	public static $icon = 'ticket';

	/**
	 * @brief	Title
	 */
	public static $title = 'invitation_create_new';

	/**
	 * @brief	Can use account credit?
	 */
	public static $canUseAccountCredit = FALSE;
	
	/**
	 * On Paid
	 *
	 * @param	\IPS\nexus\Invoice	$invoice	The invoice
	 * @return	void
	 */
	public function onPaid( \IPS\nexus\Invoice $invoice )
	{
        try
	    {
			$member = $invoice->member;
			$user 	= \IPS\invite\Member::getMember( $member );
			$user->invites_remaining = $invoice->items[0]->quantity;
			$user->save();
		}
		catch( \Exception $e ){}
	}
}