//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class invite_hook_groupModel extends _HOOK_CLASS_
{
	public function delete()
	{
		try
		{
			try
			{
				parent::delete();
		
				\IPS\Db::i()->delete( 'invite_groups', array( 'is_id=?', $this->g_id ) );
		
				\IPS\invite\Member\Group::updateGroupCache();
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}

	public function save()
	{
		try
		{
			try
			{
				$new = FALSE;
				if( $this->_new )
				{
					$new = TRUE;
				}
		
				parent::save();
		
				if( $new )
				{
					$data = \IPS\invite\Member\Group::getGroupData( $oldId );
					\IPS\Db::i()->insert( 'invite_groups', array(
						'is_id'			=> $this->g_id,
						'is_canvite'	=> isset( \IPS\Request::i()->is_canvite_checkbox )   ? 1 : 0,
						'is_unlimited'	=> isset( \IPS\Request::i()->is_unlimited_checkbox ) ? 1 : 0
					) );
		
					\IPS\invite\Member\Group::updateGroupCache();
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}