//<?php

class invite_hook_is_Settings extends _HOOK_CLASS_
{
	protected function _invitesystem()
	{
		try
		{
			try
			{
				try
				{
					try
					{
						try
						{
							\IPS\invite\Application::checkGroupsCache();
					
							$userData	= \IPS\invite\Member::getMember();
							$groupData	= \IPS\Data\Store::i()->inviteGroups[ \IPS\Member::loggedIn()->member_group_id ];
					
							if( !$groupData['is_canvite'] OR \IPS\Member::loggedIn()->revoke_access )
							{
								\IPS\Output::i()->error( 'invite_no_permission', 'INVITE SYSTEM - ACCOUNT SETTINGS/1', 403, '' );
							}
					
							$form = new \IPS\Helpers\Form( 'form', 'send_invitation' );
							$form->add( new \IPS\Helpers\Form\Text( 'invite_invited_name', NULL, TRUE, array() ) );
							$form->add( new \IPS\Helpers\Form\Email( 'invite_invited_email', NULL, TRUE, array(), function( $val )
							{
								foreach( \IPS\Login::methods( TRUE ) as $k => $handler )
								{
									if ( $handler->emailIsInUse( $val ) === TRUE )
									{
										throw new \LogicException( 'email_already_in_use' );
										break;
									}
								}
					
								try
								{
									$invite = \IPS\Db::i()->select( '*', 'invite_invites', array( 'invite_invited_email=?', $val ) )->first();
									if( $invite['invite_invited_email'] )
									{
										throw new \LogicException( 'invite_email_already_invited' );
									}
								}
								catch( \UnderflowException $e ){}
							} ) );
					
							$pending = array();
							foreach( \IPS\Db::i()->select( '*', 'invite_invites', array( "invite_sender_id=? AND invite_status=?", \IPS\Member::loggedIn()->member_id, 0 ), 'invite_id DESC' ) as $row )
							{
								$pending[ $row['invite_id'] ] = $row;
							}
					
							$iInvited = array();
							foreach( \IPS\Db::i()->select( '*', 'invite_invites', array( "invite_sender_id=? AND invite_status=?", \IPS\Member::loggedIn()->member_id, 1 ) )->join( 'core_members', 'invite_invites.invite_conv_member_id=core_members.member_id' ) as $member )
							{
								$iInvited[ $member['invite_conv_member_id'] ] = $member;
							}
					
							if( $values = $form->values() )
							{
								$newDate = 0;
								if( \IPS\Settings::i()->is_expireinvite > 0 )
								{
									$expire  = new \IPS\DateTime;
									$expire->add( new \DateInterval( 'P' . \IPS\Settings::i()->is_expireinvite . 'D' ) );
									$newDate = $expire->getTimestamp();
								}
					
								$invitationCode = md5( uniqid( microtime(), true ) );
								$invitation = new \IPS\invite\Invitation;
								$invitation->sender_id 		 = \IPS\Member::loggedIn()->member_id;
								$invitation->code			 = $invitationCode;
								$invitation->date 			 = time();
								$invitation->invited_name	 = $values['invite_invited_name'];
								$invitation->invited_email	 = $values['invite_invited_email'];
								$invitation->status			 = 0;
								$invitation->expiration_date = $newDate;
								$invitation->save();
					
								if( !$groupData['is_unlimited'] )
								{
									$userData->invites_remaining -= 1;
									$userData->save();
					
									if( $userData->invites_remaining === 0 )
									{
									\IPS\Member::clearCreateMenu();
									}
								}
					
								\IPS\invite\Invite::sendInvitation( $values['invite_invited_email'], $values['invite_invited_name'], $invitationCode, \IPS\Member::loggedIn()->email, \IPS\Member::loggedIn()->name, $newDate );
					
								\IPS\Output::i()->redirect( \IPS\Http\Url::internal( "app=core&module=system&controller=settings&area=invitesystem", 'front', 'settings_invitesystem' ), 'invite_sent' );
							}
					
							return \IPS\Theme::i()->getTemplate( 'settings', 'invite', 'front' )->settingsInviteSystem( $form, $iInvited, $pending );
						}
						catch ( \Error | \RuntimeException $e )
						{
							if ( method_exists( get_parent_class(), __FUNCTION__ ) )
							{
								return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
							}
							else
							{
								throw $e;
							}
						}
					}
					catch ( \Error | \RuntimeException $e )
					{
						if ( method_exists( get_parent_class(), __FUNCTION__ ) )
						{
							return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
						}
						else
						{
							throw $e;
						}
					}
				}
				catch ( \Error | \RuntimeException $e )
				{
					if ( method_exists( get_parent_class(), __FUNCTION__ ) )
					{
						return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
					}
					else
					{
						throw $e;
					}
				}
			}
			catch ( \Error | \RuntimeException $e )
			{
				if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
				{
					\IPS\Log::log( $e, 'hook_exception' );
				}
	
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}