//<?php

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	exit;
}

class invite_hook_is_SocialMediaForm extends _HOOK_CLASS_
{
	public function add( $input, $after=NULL, $tab=NULL )
	{
		try
		{
			try
			{
				$form = parent::add( $input, $after, $tab );
		
				if( \IPS\Dispatcher::i()->application->directory === 'core' AND \IPS\Dispatcher::i()->module->key == 'system' AND \IPS\Dispatcher::i()->controller == 'register' AND \IPS\Request::i()->do == 'complete' )
				{
					if ( \IPS\Settings::i()->is_on )
					{
						if ( \IPS\Settings::i()->is_requireinvitesocialmedia )
						{
							parent::add( new \IPS\Helpers\Form\Text( 'invite_code_req', NULL, TRUE, array( 'maxLength' => 32 ), function( $val )
							{
								try
								{
									if( $val === "0" )
									{
										throw new \DomainException( 'invite_does_not_exist' );
									}
		
									if( !$val )
									{
										return true;
									}
		
									try
									{
										$invite = \IPS\Db::i()->select( '*', 'invite_invites', array( 'invite_code=?', $val ) )->first();
									}
									catch( \UnderflowException $ex )
									{
										/* The invitation code does not exists */
										throw new \DomainException( 'invite_does_not_exist' );
									}
		
									/* The invitation code is already in use */
									if( $invite['invite_status'] == 1 )
									{
										throw new \DomainException(  'invite_already_in_use' );
									}
								
									/* The invitation code is already in use */
									if( $invite['invite_status'] == 2 )
									{
										throw new \DomainException( 'invite_already_expired' );
									}
								}
								catch( \OutOfRangeException $e )
								{
									return true;
								}
							} ), 'email_address' );
		
							if( \IPS\Settings::i()->is_emailfrominvite AND isset( \IPS\Request::i()->email_address ) AND \IPS\Request::i()->email_address )
							{
								$form->elements[''][ 'email_address' ]->value = \IPS\Request::i()->email_address;
							}
						}
						else
						{
							parent::add( new \IPS\Helpers\Form\Text( 'invite_code_opt', NULL, FALSE, array( 'maxLength' => 32 ), function( $val )
							{
								try
								{
									if( $val === "0" )
									{
										throw new \DomainException( 'invite_does_not_exist' );
									}
								
									if( !$val )
									{
										return true;
									}
		
									try
									{
										$invite = \IPS\Db::i()->select( '*', 'invite_invites', array( 'invite_code=?', $val ) )->first();
									}
									catch( \UnderflowException $ex )
									{
										/* The invitation code does not exists */
										throw new \DomainException( 'invite_does_not_exist' );
									}
		
										/* The invitation code is already in use */
									if( $invite['invite_status'] == 1 )
									{
										throw new \DomainException( 'invite_already_in_use' );
									}
		
									/* The invitation code is already in use */
									if( $invite['invite_status'] == 2 )
									{
										throw new \DomainException( 'invite_already_expired' );
									}
								}
								catch( \OutOfRangeException $e )
								{
									return true;
								}
							} ), 'email_address' );
						}
					}
				}
		
				return $form;
			}
			catch ( \Error | \RuntimeException $e )
			{
				if ( method_exists( get_parent_class(), __FUNCTION__ ) )
				{
					return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
				}
				else
				{
					throw $e;
				}
			}
		}
		catch ( \Error | \RuntimeException $e )
		{
			if( \defined( '\IPS\DEBUG_HOOKS' ) AND \IPS\DEBUG_HOOKS )
			{
				\IPS\Log::log( $e, 'hook_exception' );
			}

			if ( method_exists( get_parent_class(), __FUNCTION__ ) )
			{
				return \call_user_func_array( 'parent::' . __FUNCTION__, \func_get_args() );
			}
			else
			{
				throw $e;
			}
		}
	}
}