<?php

namespace IPS\invite\modules\admin\invite;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _bonus extends \IPS\Dispatcher\Controller
{
	public static $csrfProtected = TRUE;

	protected function manage()
	{
		\IPS\Dispatcher::i()->checkAcpPermission( 'bonus_manage' );

		$form = new \IPS\Helpers\Form( 'update', 'add_bonus' );
		$form->addHtml( \IPS\Member::loggedIn()->language()->addToStack( 'is_bonus_background_task' ) );
		$form->add( new \IPS\Helpers\Form\Radio( 'is_bonus_type', 'member', TRUE, array(
			'options' => array(
				'member' 	=> 'bonus_to_member',
				'group' 	=> 'bonus_to_group'
			),
			'toggles'	=> array(
				'member'	=> array( 'is_bonus_type_member' ),
				'group'		=> array( 'is_bonus_type_group', 'is_bonus_type_group_others' )
			)
		) ) );

		$form->add( new \IPS\Helpers\Form\Member( 'is_bonus_type_member', NULL, FALSE, array(), function( $member ) use ( $form )
		{
			if ( \IPS\Request::i()->is_bonus_type === 'member' )
			{
				if( !\is_object( $member ) )
				{
					throw new \InvalidArgumentException( 'is_no_member_selected' );
				}
			}
		},
		NULL, NULL, 'is_bonus_type_member' ) );
		$form->add( new \IPS\Helpers\Form\Select( 'is_bonus_type_group', NULL, FALSE, array( 'options'	=> \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal' ), NULL, NULL, NULL, 'is_bonus_type_group' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_bonus_type_group_others', NULL, FALSE, array(), NULL, NULL, NULL, 'is_bonus_type_group_others' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'is_bonus_nr', 1, FALSE, array( 'min' => 1, 'max' => 999999 ) ) );

		if( $values = $form->values() )
		{
			if( $values['is_bonus_type'] == 'member' )
			{
				$user = \IPS\invite\Member::getMember( $values['is_bonus_type_member'] );
				$user->invites_remaining += $values['is_bonus_nr'];
				$user->save();

				\IPS\Member::clearCreateMenu();
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=invite&module=invite&controller=bonus' ), 'bonus_given' );
			}
			else
			{
				$data = array();
				if ( $values['is_bonus_type_group_others'] )
				{
					$where = array( "member_group_id=?" . $values['is_bonus_type_group'] . " OR FIND_IN_SET(" . $values['is_bonus_type_group'] . ",mgroup_others)" );
				}
				else
				{
					$where = array( 'member_group_id=?', $values['is_bonus_type_group'] );
				}

				$data['group'] = $where;
				$data['bonus'] = $values['is_bonus_nr'];

				\IPS\Task::queue( 'invite', 'Bonus', $data, 1 );
				\IPS\Output::i()->redirect( \IPS\Http\Url::internal( 'app=invite&module=invite&controller=bonus' ), 'completed' );
			}
		}

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('menu__invite_invite_bonus');
		\IPS\Output::i()->output = $form;
	}
}