<?php


namespace IPS\invite\modules\admin\invite;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _campaign extends \IPS\Node\Controller
{
	public static $csrfProtected = TRUE;
	protected $nodeClass = 'IPS\invite\Campaign';

	public $_descriptionHtml = TRUE;

	public function execute()
	{
		\IPS\Dispatcher::i()->checkAcpPermission( 'campaign_manage' );

		if( ! \IPS\Settings::i()->is_campaign_on )
		{
			\IPS\Output::i()->error( 'campaign_disabled', 'INVITE SYSTEM - CAMPAIGN/1', 403, '' );
		}
	
		parent::execute();
	}

	public function members()
	{
		if( !\IPS\Request::i()->campaign )
		{
			\IPS\Output::i()->error( 'node_error', 'INVITE SYSTEM - CAMPAIGN: VIEW MEMBERS/1', 404, '' );
		}

		$table = new \IPS\Helpers\Table\Db( 'invite_campaigns_members', \IPS\Http\Url::internal( 'app=invite&module=invite&controller=campaign&do=members&id=' . \IPS\Request::i()->campaign ), array( array( 'cpg_mid_campain=?', \IPS\Request::i()->campaign ) ) );

        $table->joins = array(
            array(
                'select' => 'core_members.*',
                'from'   => 'core_members',
                'where'  => 'core_members.member_id=invite_campaigns_members.cpg_mid_mid'
            )
        );

		$table->tableTemplate 	= array( \IPS\Theme::i()->getTemplate( 'view', 'invite', 'admin' ), 'membersListTable' );
		$table->rowsTemplate 	= array( \IPS\Theme::i()->getTemplate( 'view', 'invite', 'admin' ), 'membersListRows' );
		$table->limit			= 6;
		$table->sortBy 			= $table->sortBy ?: 'name';
		$table->sortDirection 	= $table->sortDirection ?: 'asc';
		$table->classes[]		= "ipsPad";

		\IPS\Output::i()->output = \IPS\Theme::i()->getTemplate( 'view', 'invite', 'admin' )->membersList( (string) $table );
	}
}