<?php


namespace IPS\invite\modules\admin\invite;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * settings
 */
class _settings extends \IPS\Dispatcher\Controller
{
	/**
	 * ...
	 *
	 * @return	void
	 */
	protected function manage()
	{
		\IPS\Dispatcher::i()->checkAcpPermission( 'settings_manage' );

		$form = new \IPS\Helpers\Form;

		$form->addTab( 'is_tab_general' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_on', \IPS\Settings::i()->is_on, FALSE, array( 'togglesOn' => array( 'is_requireinvite', /*'is_requireinvitesocialmedia',*/ 'is_restoreinvitation', 'is_showicon', 'is_show_invited_by', 'is_show_inviter_email', 'is_expireinvite', 'is_contentcountperinvite', 'is_showmoremenu', "{$form->id}_header_is_header_invitations", "{$form->id}_tab_is_tab_invitations", "{$form->id}_tab_is_tab_registration", "{$form->id}_tab_is_tab_membersshop", "{$form->id}_tab_is_tab_commerce", "{$form->id}_tab_is_tab_campaign" ) ) ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_showmoremenu', \IPS\Settings::i()->is_showmoremenu, FALSE, array(), NULL, NULL, NULL, 'is_showmoremenu' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_showicon', \IPS\Settings::i()->is_showicon, FALSE, array( 'togglesOn' => array('is_showicon_nr' ) ), NULL, NULL, NULL, 'is_showicon' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_showicon_nr', \IPS\Settings::i()->is_showicon_nr, FALSE, array(), NULL, NULL, NULL, 'is_showicon_nr' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_show_inviter_email', \IPS\Settings::i()->is_show_inviter_email, FALSE, array(), NULL, NULL, NULL, 'is_show_inviter_email' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_show_invited_by', \IPS\Settings::i()->is_show_invited_by, FALSE, array(), NULL, NULL, NULL, 'is_show_invited_by' ) );
		
		$form->addTab( 'is_tab_invitations' );
		
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_restoreinvitation', \IPS\Settings::i()->is_restoreinvitation, FALSE, array(), NULL, NULL, NULL, 'is_restoreinvitation' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'is_expireinvite', \IPS\Settings::i()->is_expireinvite, FALSE, array( 'unlimited' => 0, 'unlimitedLang' => 'never' ), NULL, \IPS\Member::loggedIn()->language()->addToStack('after'), \IPS\Member::loggedIn()->language()->addToStack('days'), 'is_expireinvite' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'is_contentcountperinvite', \IPS\Settings::i()->is_contentcountperinvite, FALSE, array( 'unlimited' => 0, 'unlimitedLang' => 'never' ), NULL, \IPS\Member::loggedIn()->language()->addToStack('is_contentcountperinvite_ae'), \IPS\Member::loggedIn()->language()->addToStack('members_member_posts'), 'is_contentcountperinvite' ) );

		$form->addTab( 'is_tab_registration' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_requireinvite', \IPS\Settings::i()->is_requireinvite, FALSE, array(), NULL, NULL, NULL, 'is_requireinvite' ) );
		//$form->add( new \IPS\Helpers\Form\YesNo( 'is_requireinvitesocialmedia', \IPS\Settings::i()->is_requireinvitesocialmedia, FALSE, array(), NULL, NULL, NULL, 'is_requireinvitesocialmedia' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_emailfrominvite', \IPS\Settings::i()->is_emailfrominvite, FALSE, array(), NULL, NULL, NULL, 'is_emailfrominvite' ) );
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_registrationgroup_toggle', \IPS\Settings::i()->is_registrationgroup_toggle, FALSE, array( 'togglesOn' => array( 'is_registrationgroup' ) ), NULL, NULL, NULL, 'is_registrationgroup_toggle' ) );
		$form->add( new \IPS\Helpers\Form\Select( 'is_registrationgroup', array_filter( explode( ',', \IPS\Settings::i()->is_registrationgroup ) ), FALSE, array( 'options' => \IPS\Member\Group::groups( TRUE, FALSE ), 'parse' => 'normal' ), NULL, NULL, NULL, 'is_registrationgroup' ) );		
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_registration_earninvitations', \IPS\Settings::i()->is_registration_earninvitations, FALSE, array( 'togglesOn' => array( 'is_registration_earninvitations_nr' ) ), NULL, NULL, NULL, 'is_registration_earninvitations' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'is_registration_earninvitations_nr', \IPS\Settings::i()->is_registration_earninvitations_nr, FALSE, array(), NULL, NULL, NULL, 'is_registration_earninvitations_nr' ) );

		if( \IPS\invite\Invite::canUsePoints() )
		{
			$form->addTab( 'is_tab_membersshop' );
			$form->addHeader( 'is_tab_membersshop_enable' );
			$form->add( new \IPS\Helpers\Form\YesNo( 'is_mshop', \IPS\Settings::i()->is_mshop, FALSE, array( 'togglesOn' => array( "{$form->id}_header_is_tab_membersshop_earn", 'is_mshop_points', "{$form->id}_header_is_tab_membersshop_pay", 'is_mshop_paypoints' ) ), NULL, NULL, NULL, 'is_mshop' ) );

			$form->addHeader( 'is_tab_membersshop_earn' );
			$form->add( new \IPS\Helpers\Form\Number( 'is_mshop_points', \IPS\Settings::i()->is_mshop_points, TRUE, array(), NULL, NULL, NULL, 'is_mshop_points' ) );

			$form->addHeader( 'is_tab_membersshop_pay' );
			$form->add( new \IPS\Helpers\Form\YesNo( 'is_mshop_paypoints', \IPS\Settings::i()->is_mshop_paypoints, FALSE, array( 'togglesOn' => array( 'is_mshop_paypoints_points' ) ), NULL, NULL, NULL, 'is_mshop_paypoints' ) );
			$form->add( new \IPS\Helpers\Form\Number( 'is_mshop_paypoints_points', \IPS\Settings::i()->is_mshop_paypoints_points, TRUE, array(), NULL, NULL, \IPS\Settings::i()->ms_points_name, 'is_mshop_paypoints_points' ) );
		}

		if( \IPS\invite\Invite::canUseCommerce() )
		{
			$form->addTab( 'is_tab_commerce' );
			$form->add( new \IPS\Helpers\Form\YesNo( 'is_commerce', \IPS\Settings::i()->is_commerce, FALSE, array( 'togglesOn' => array( 'is_commerce_cost', 'is_payment_method', 'is_tax' ) ), NULL, NULL, NULL, 'is_commerce' ) );
			$form->add( new \IPS\nexus\Form\Money( 'is_commerce_cost', \IPS\Settings::i()->is_commerce_cost ? json_decode( \IPS\Settings::i()->is_commerce_cost, TRUE ) : 0, NULL, array(), function( $val )
			{
				if ( !$val AND \IPS\Request::i()->is_commerce_checkbox )
				{
					throw new \DomainException('form_required');
				}

				if( \IPS\Request::i()->is_commerce_checkbox )
				{
					foreach( \IPS\nexus\Money::currencies() as $currency )
					{
						if( !isset( $val[ $currency ]->currency, $currency ) )
						{
							throw new \DomainException('is_invalid_price2');
						}
						if( ( $val[ $currency ]->amount->isZero() OR !$val[ $currency ]->amount->isPositive() ) )
						{
							throw new \DomainException('is_invalid_price1');
						}
					}
				}
			}, NULL, NULL, 'is_commerce_cost' ) );
			$form->add( new \IPS\Helpers\Form\Node( 'is_payment_method', ( \IPS\Settings::i()->is_payment_method ) ? explode( ',', \IPS\Settings::i()->is_payment_method ) : 0, FALSE, array( 'class' => '\IPS\nexus\Gateway', 'zeroVal' => 'no_restriction', 'multiple' => TRUE ), NULL, NULL, NULL, 'is_payment_method' ) );
			$form->add( new \IPS\Helpers\Form\Node( 'is_tax', \IPS\Settings::i()->is_tax ?:0, FALSE, array( 'class' => '\IPS\nexus\Tax', 'zeroVal' => 'do_not_tax' ), NULL, NULL, NULL, 'is_tax' ) );
		}

		$form->addTab( 'is_tab_campaign' );
		$form->add( new \IPS\Helpers\Form\YesNo( 'is_campaign_on', \IPS\Settings::i()->is_campaign_on, FALSE, array( 'togglesOn' => array( 'is_require_campaign_code', 'is_campaign_code_len', 'is_campaign_code_type' ) ), NULL, NULL, NULL, 'is_campaign_on' ) );
		$form->add( new \IPS\Helpers\Form\Number( 'is_campaign_code_len', \IPS\Settings::i()->is_campaign_code_len, FALSE, array( 'min' => 4, 'max' => 32 ), NULL, NULL, NULL, 'is_campaign_code_len' ) );
		$form->add( new \IPS\Helpers\Form\Radio( 'is_campaign_code_type', \IPS\Settings::i()->is_campaign_code_type, FALSE, array( 'options' => array(
			'numbers'		=> 'is_campaign_numbers',
			'letters'		=> 'is_campaign_letters',
			'both'			=> 'is_campaign_both'
		) ), NULL, NULL, NULL, 'is_campaign_code_type' ) );

		if ( $values = $form->values( TRUE ) )
		{
			$form->saveAsSettings( $values );
			\IPS\Member::clearCreateMenu();
			\IPS\Session::i()->log( 'acplogs__invite_settings' );
		}

		\IPS\Output::i()->title = \IPS\Member::loggedIn()->language()->addToStack('settings');
		\IPS\Output::i()->output = $form;
	}
}