<?php

namespace IPS\invite\setup\upg_200029;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * 2.5.0 Upgrade Code
 */
class _Upgrade
{
	public function step1()
	{
		foreach( \IPS\Db::i()->select( '*', 'core_members', array( 'invites_remaining>? OR invite_offset>? OR invited_by>?', 0, 0, 0 ), 'member_id ASC' ) as $row )
		{
			$user = new \IPS\invite\Member;

			$user->member_id 		 = $row['member_id'];
			$user->invites_remaining = $row['invites_remaining'];
			$user->invite_offset 	 = $row['invite_offset'];
			$user->invited_by 		 = $row['invited_by'];
			$user->revoke_access 	 = $row['revoke_access'];

			$user->save();
		}

		return TRUE;
	}

	public function step1CustomTitle()
	{
		return "Handling members data";
	}

	public function step2()
	{
		try
		{
			\IPS\Db::i()->dropColumn( 'core_members', array( 'invites_remaining', 'invite_offset', 'invited_by', 'revoke_access' ) );
		}
		catch( \IPS\Db\Exception $e )
		{
			if( $e->getCode() <> 1091 )
			{
				throw $e;
			}
		}

		return TRUE;
	}

	public function step2CustomTitle()
	{
		return "Dropping columns from core tables";
	}
}