<?php

namespace IPS\invite\setup\upg_200030;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !\defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * 2.6.0 Upgrade Code
 */
class _Upgrade
{
	public function step1()
	{
		foreach( \IPS\Db::i()->select( '*', 'core_groups' ) as $group )
		{
			\IPS\invite\Member\Group::setGroupData( $group['g_id'], $group['is_canvite'], $group['is_unlimited'] );
		}

		return TRUE;
	}

	public function step1CustomTitle()
	{
		return "Moving groups data for a proper table";
	}

	public function step2()
	{
		try
		{
			\IPS\Db::i()->dropColumn( 'core_groups', array( 'is_canvite', 'is_unlimited' ) );
		}
		catch( \IPS\Db\Exception $e )
		{
			if( $e->getCode() <> 1091 )
			{
				throw $e;
			}
		}

		return TRUE;
	}

	public function step2CustomTitle()
	{
		return "Dropping columns from core tables";
	}
}