<?php

namespace IPS\invite\Member;

/* To prevent PHP errors (extending class does not exist) revealing path */
if( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

class _Group
{
	public static function getGroupData( $groupId )
	{
		if( !isset( \IPS\Data\Store::i()->inviteGroups ) )
		{
			$groups = iterator_to_array( \IPS\Db::i()->select( '*', 'invite_groups' )->setKeyField( 'is_id' ) );
			\IPS\Data\Store::i()->inviteGroups = $groups;
		}

		try
		{
			$data = \IPS\Data\Store::i()->inviteGroups[ $groupId ];
		}
		catch( \UnderflowException $e )
		{
			$data = array( 'is_canvite' => 1, 'is_unlimited' => 0 );
		}

		return $data;
	}

	public static function setGroupData( $groupId, $canInvite, $isUnlimited )
	{
		\IPS\Db::i()->replace( 'invite_groups',
			array(
				'is_id'			=> $groupId,
				'is_canvite'	=> $canInvite,
				'is_unlimited'	=> $isUnlimited
			)
		);

		static::updateGroupCache();
	}

	public static function updateGroupCache()
	{
		if( isset( \IPS\Data\Store::i()->inviteGroups ) )
		{
			unset( \IPS\Data\Store::i()->inviteGroups );
		}

		$groups = iterator_to_array( \IPS\Db::i()->select( '*', 'invite_groups' )->setKeyField( 'is_id' ) );
		\IPS\Data\Store::i()->inviteGroups = $groups;
	}

	public function dummy()
	{
		//nothing here
	}
}